1#!/bin/bash
2#
3# Run a kvm-based test of the specified tree on the specified configs.
4# Fully automated run and error checking, no graphics console.
5#
6# Execute this in the source tree.  Do not run it as a background task
7# because qemu does not seem to like that much.
8#
9# Usage: kvm-test-1-run.sh config builddir resdir seconds qemu-args boot_args
10#
11# qemu-args defaults to "-enable-kvm -nographic", along with arguments
12#			specifying the number of CPUs and other options
13#			generated from the underlying CPU architecture.
14# boot_args defaults to value returned by the per_version_boot_params
15#			shell function.
16#
17# Anything you specify for either qemu-args or boot_args is appended to
18# the default values.  The "-smp" value is deduced from the contents of
19# the config fragment.
20#
21# More sophisticated argument parsing is clearly needed.
22#
23# This program is free software; you can redistribute it and/or modify
24# it under the terms of the GNU General Public License as published by
25# the Free Software Foundation; either version 2 of the License, or
26# (at your option) any later version.
27#
28# This program is distributed in the hope that it will be useful,
29# but WITHOUT ANY WARRANTY; without even the implied warranty of
30# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
31# GNU General Public License for more details.
32#
33# You should have received a copy of the GNU General Public License
34# along with this program; if not, you can access it online at
35# http://www.gnu.org/licenses/gpl-2.0.html.
36#
37# Copyright (C) IBM Corporation, 2011
38#
39# Authors: Paul E. McKenney <paulmck@linux.vnet.ibm.com>
40
41T=/tmp/kvm-test-1-run.sh.$$
42trap 'rm -rf $T' 0
43mkdir $T
44
45. $KVM/bin/functions.sh
46. $CONFIGFRAG/ver_functions.sh
47
48config_template=${1}
49config_dir=`echo $config_template | sed -e 's,/[^/]*$,,'`
50title=`echo $config_template | sed -e 's/^.*\///'`
51builddir=${2}
52if test -z "$builddir" -o ! -d "$builddir" -o ! -w "$builddir"
53then
54	echo "kvm-test-1-run.sh :$builddir: Not a writable directory, cannot build into it"
55	exit 1
56fi
57resdir=${3}
58if test -z "$resdir" -o ! -d "$resdir" -o ! -w "$resdir"
59then
60	echo "kvm-test-1-run.sh :$resdir: Not a writable directory, cannot store results into it"
61	exit 1
62fi
63echo ' ---' `date`: Starting build
64echo ' ---' Kconfig fragment at: $config_template >> $resdir/log
65touch $resdir/ConfigFragment.input $resdir/ConfigFragment
66if test -r "$config_dir/CFcommon"
67then
68	echo " --- $config_dir/CFcommon" >> $resdir/ConfigFragment.input
69	cat < $config_dir/CFcommon >> $resdir/ConfigFragment.input
70	config_override.sh $config_dir/CFcommon $config_template > $T/Kc1
71	grep '#CHECK#' $config_dir/CFcommon >> $resdir/ConfigFragment
72else
73	cp $config_template $T/Kc1
74fi
75echo " --- $config_template" >> $resdir/ConfigFragment.input
76cat $config_template >> $resdir/ConfigFragment.input
77grep '#CHECK#' $config_template >> $resdir/ConfigFragment
78if test -n "$TORTURE_KCONFIG_ARG"
79then
80	echo $TORTURE_KCONFIG_ARG | tr -s " " "\012" > $T/cmdline
81	echo " --- --kconfig argument" >> $resdir/ConfigFragment.input
82	cat $T/cmdline >> $resdir/ConfigFragment.input
83	config_override.sh $T/Kc1 $T/cmdline > $T/Kc2
84	# Note that "#CHECK#" is not permitted on commandline.
85else
86	cp $T/Kc1 $T/Kc2
87fi
88cat $T/Kc2 >> $resdir/ConfigFragment
89
90base_resdir=`echo $resdir | sed -e 's/\.[0-9]\+$//'`
91if test "$base_resdir" != "$resdir" -a -f $base_resdir/bzImage -a -f $base_resdir/vmlinux
92then
93	# Rerunning previous test, so use that test's kernel.
94	QEMU="`identify_qemu $base_resdir/vmlinux`"
95	BOOT_IMAGE="`identify_boot_image $QEMU`"
96	KERNEL=$base_resdir/${BOOT_IMAGE##*/} # use the last component of ${BOOT_IMAGE}
97	ln -s $base_resdir/Make*.out $resdir  # for kvm-recheck.sh
98	ln -s $base_resdir/.config $resdir  # for kvm-recheck.sh
99	# Arch-independent indicator
100	touch $resdir/builtkernel
101elif kvm-build.sh $T/Kc2 $builddir
102then
103	# Had to build a kernel for this test.
104	QEMU="`identify_qemu $builddir/vmlinux`"
105	BOOT_IMAGE="`identify_boot_image $QEMU`"
106	cp $builddir/Make*.out $resdir
107	cp $builddir/vmlinux $resdir
108	cp $builddir/.config $resdir
109	if test -n "$BOOT_IMAGE"
110	then
111		cp $builddir/$BOOT_IMAGE $resdir
112		KERNEL=$resdir/${BOOT_IMAGE##*/}
113		# Arch-independent indicator
114		touch $resdir/builtkernel
115	else
116		echo No identifiable boot image, not running KVM, see $resdir.
117		echo Do the torture scripts know about your architecture?
118	fi
119	parse-build.sh $resdir/Make.out $title
120else
121	# Build failed.
122	cp $builddir/Make*.out $resdir
123	cp $builddir/.config $resdir || :
124	echo Build failed, not running KVM, see $resdir.
125	if test -f $builddir.wait
126	then
127		mv $builddir.wait $builddir.ready
128	fi
129	exit 1
130fi
131if test -f $builddir.wait
132then
133	mv $builddir.wait $builddir.ready
134fi
135while test -f $builddir.ready
136do
137	sleep 1
138done
139seconds=$4
140qemu_args=$5
141boot_args=$6
142
143cd $KVM
144kstarttime=`awk 'BEGIN { print systime() }' < /dev/null`
145if test -z "$TORTURE_BUILDONLY"
146then
147	echo ' ---' `date`: Starting kernel
148fi
149
150# Generate -smp qemu argument.
151qemu_args="-enable-kvm -nographic $qemu_args"
152cpu_count=`configNR_CPUS.sh $resdir/ConfigFragment`
153cpu_count=`configfrag_boot_cpus "$boot_args" "$config_template" "$cpu_count"`
154vcpus=`identify_qemu_vcpus`
155if test $cpu_count -gt $vcpus
156then
157	echo CPU count limited from $cpu_count to $vcpus
158	touch $resdir/Warnings
159	echo CPU count limited from $cpu_count to $vcpus >> $resdir/Warnings
160	cpu_count=$vcpus
161fi
162qemu_args="`specify_qemu_cpus "$QEMU" "$qemu_args" "$cpu_count"`"
163
164# Generate architecture-specific and interaction-specific qemu arguments
165qemu_args="$qemu_args `identify_qemu_args "$QEMU" "$resdir/console.log"`"
166
167# Generate qemu -append arguments
168qemu_append="`identify_qemu_append "$QEMU"`"
169
170# Pull in Kconfig-fragment boot parameters
171boot_args="`configfrag_boot_params "$boot_args" "$config_template"`"
172# Generate kernel-version-specific boot parameters
173boot_args="`per_version_boot_params "$boot_args" $resdir/.config $seconds`"
174
175if test -n "$TORTURE_BUILDONLY"
176then
177	echo Build-only run specified, boot/test omitted.
178	touch $resdir/buildonly
179	exit 0
180fi
181echo "NOTE: $QEMU either did not run or was interactive" > $resdir/console.log
182echo $QEMU $qemu_args -m 512 -kernel $KERNEL -append \"$qemu_append $boot_args\" > $resdir/qemu-cmd
183( $QEMU $qemu_args -m 512 -kernel $KERNEL -append "$qemu_append $boot_args"& echo $! > $resdir/qemu_pid; wait `cat  $resdir/qemu_pid`; echo $? > $resdir/qemu-retval ) &
184commandcompleted=0
185sleep 10 # Give qemu's pid a chance to reach the file
186if test -s "$resdir/qemu_pid"
187then
188	qemu_pid=`cat "$resdir/qemu_pid"`
189	echo Monitoring qemu job at pid $qemu_pid
190else
191	qemu_pid=""
192	echo Monitoring qemu job at yet-as-unknown pid
193fi
194while :
195do
196	if test -z "$qemu_pid" -a -s "$resdir/qemu_pid"
197	then
198		qemu_pid=`cat "$resdir/qemu_pid"`
199	fi
200	kruntime=`awk 'BEGIN { print systime() - '"$kstarttime"' }' < /dev/null`
201	if test -z "$qemu_pid" || kill -0 "$qemu_pid" > /dev/null 2>&1
202	then
203		if test $kruntime -ge $seconds
204		then
205			break;
206		fi
207		sleep 1
208	else
209		commandcompleted=1
210		if test $kruntime -lt $seconds
211		then
212			echo Completed in $kruntime vs. $seconds >> $resdir/Warnings 2>&1
213			grep "^(qemu) qemu:" $resdir/kvm-test-1-run.sh.out >> $resdir/Warnings 2>&1
214			killpid="`sed -n "s/^(qemu) qemu: terminating on signal [0-9]* from pid \([0-9]*\).*$/\1/p" $resdir/Warnings`"
215			if test -n "$killpid"
216			then
217				echo "ps -fp $killpid" >> $resdir/Warnings 2>&1
218				ps -fp $killpid >> $resdir/Warnings 2>&1
219			fi
220		else
221			echo ' ---' `date`: "Kernel done"
222		fi
223		break
224	fi
225done
226if test -z "$qemu_pid" -a -s "$resdir/qemu_pid"
227then
228	qemu_pid=`cat "$resdir/qemu_pid"`
229fi
230if test $commandcompleted -eq 0 -a -n "$qemu_pid"
231then
232	echo Grace period for qemu job at pid $qemu_pid
233	oldline="`tail $resdir/console.log`"
234	while :
235	do
236		kruntime=`awk 'BEGIN { print systime() - '"$kstarttime"' }' < /dev/null`
237		if kill -0 $qemu_pid > /dev/null 2>&1
238		then
239			:
240		else
241			break
242		fi
243		must_continue=no
244		newline="`tail $resdir/console.log`"
245		if test "$newline" != "$oldline" && echo $newline | grep -q ' [0-9]\+us : '
246		then
247			must_continue=yes
248		fi
249		last_ts="`tail $resdir/console.log | grep '^\[ *[0-9]\+\.[0-9]\+]' | tail -1 | sed -e 's/^\[ *//' -e 's/\..*$//'`"
250		if test -z "last_ts"
251		then
252			last_ts=0
253		fi
254		if test "$newline" != "$oldline" -a "$last_ts" -lt $((seconds + $TORTURE_SHUTDOWN_GRACE))
255		then
256			must_continue=yes
257		fi
258		if test $must_continue = no -a $kruntime -ge $((seconds + $TORTURE_SHUTDOWN_GRACE))
259		then
260			echo "!!! PID $qemu_pid hung at $kruntime vs. $seconds seconds" >> $resdir/Warnings 2>&1
261			kill -KILL $qemu_pid
262			break
263		fi
264		oldline=$newline
265		sleep 10
266	done
267elif test -z "$qemu_pid"
268then
269	echo Unknown PID, cannot kill qemu command
270fi
271
272parse-torture.sh $resdir/console.log $title
273parse-console.sh $resdir/console.log $title
274